# SPDX-License-Identifier: Zlib
# SPDX-FileCopyrightText: 2022 CERN (home.cern)
# SPDX-FileContributor: Author: Sylvain Fargier <sylvain.fargier@cern.ch>

set(CPACK_PROJECT_CONFIG_FILE "${CMAKE_SOURCE_DIR}/cmake/PackConfig.cmake")

string(TOLOWER "${CMAKE_PROJECT_NAME}" PACKAGE_NAME)
set(CPACK_PACKAGE_NAME "${PACKAGE_NAME}")
set(CPACK_PACKAGE_VENDOR "CERN")
set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "${CMAKE_PROJECT_NAME}")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_DESCRIPTION "${CMAKE_PROJECT_DESCRIPTION}")
set(CPACK_RPM_PACKAGE_DESCRIPTION "${CMAKE_PROJECT_DESCRIPTION}")

set(CPACK_PACKAGE_CONTACT "Sylvain Fargier <sylvain.fargier@cern.ch>")

# Generate debug package
set(CPACK_RPM_DEBUGINFO_PACKAGE ON)
set(CPACK_RPM_BUILD_SOURCE_DIRS_PREFIX "/debug")
set(CPACK_RPM_PACKAGE_RELEASE_DIST ON)
set(CPACK_RPM_FILE_NAME "RPM-DEFAULT")

set(CPACK_DEBIAN_FILE_NAME "DEB-DEFAULT")
set(CPACK_DEBIAN_PACKAGE_RELEASE "1")

# Host detection and debian release packaging
if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND CMAKE_VERSION VERSION_GREATER_EQUAL "3.22")
  cmake_host_system_information(RESULT DISTRIB_ID QUERY DISTRIB_ID)
  cmake_host_system_information(RESULT DISTRIB_VERSION_ID QUERY DISTRIB_VERSION_ID)
  if(DISTRIB_ID STREQUAL "debian")
    set(CPACK_DEBIAN_PACKAGE_RELEASE "${CPACK_DEBIAN_PACKAGE_RELEASE}+0deb${DISTRIB_VERSION_ID}u1")
  endif()
  if(DISTRIB_ID STREQUAL "rhel")
    string(REGEX REPLACE "([0-9]).*$" "\\1" DISTRIB_MAJOR_ID "${DISTRIB_VERSION_ID}")
    set(CPACK_RPM_PACKAGE_RELEASE "1.${DISTRIB_ID}${DISTRIB_MAJOR_ID}")
    set(CPACK_RPM_PACKAGE_RELEASE_DIST OFF)
  endif()
  message(STATUS "Linux distro: ${DISTRIB_ID} ${DISTRIB_VERSION_ID}")
endif()

set(CPACK_RPM_PACKAGE_AUTOREQ 1)

add_custom_target(rpm-package COMMAND ${CMAKE_CPACK_COMMAND} -G RPM)
add_custom_target(deb-package COMMAND ${CMAKE_CPACK_COMMAND} -G DEB
  -DCMAKE_INSTALL_LIBDIR=lib -DCMAKE_BUILD_TYPE=Release)

include(CPack)
